var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from "react";
import { TransitionMotion } from "react-motion";
import AnimationPhases from "./AnimationPhases";
import { combineStyleCalculator } from "./utils";
var ArenaSceneLoadMotion = /** @class */ (function (_super) {
    __extends(ArenaSceneLoadMotion, _super);
    function ArenaSceneLoadMotion() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ArenaSceneLoadMotion.prototype.componentWillMount = function () {
        var _this = this;
        this.props.actions.loadSceneBundle(this.props.sceneBundleThunk);
        this.setState({
            initStyles: this.props.initStyles.concat([
                {
                    key: "nextPhase",
                    style: { phase: AnimationPhases.LOADING }
                }
            ]),
            styleCalculator: combineStyleCalculator(this.props.styleCalculators, this.props.phase, this.props.nextPhaseCheckers, this.props.isSceneReady, function (phase) {
                return setImmediate(function () { return _this.props.actions.nextPhase(phase); });
            }),
            playElement: this.props.bundle
                ? this.props.children(this.props.bundle)
                : null
        });
    };
    ArenaSceneLoadMotion.prototype.componentWillReceiveProps = function (nextProps) {
        var state = Object.assign({}, this.state);
        if (this.props.bundle !== nextProps.bundle ||
            this.props.children !== nextProps.children) {
            state.playElement = nextProps.bundle
                ? nextProps.children(nextProps.bundle)
                : null;
        }
        if (nextProps.sceneBundleThunk !== this.props.sceneBundleThunk) {
            nextProps.actions.loadSceneBundle(nextProps.sceneBundleThunk);
        }
        if (nextProps.actions !== this.props.actions ||
            nextProps.phase !== this.props.phase ||
            nextProps.styleCalculators !== this.props.styleCalculators ||
            nextProps.nextPhaseCheckers !== this.props.nextPhaseCheckers ||
            nextProps.isSceneReady !== this.props.isSceneReady) {
            state.styleCalculator = combineStyleCalculator(nextProps.styleCalculators, nextProps.phase, nextProps.nextPhaseCheckers, nextProps.isSceneReady, function (phase) { return setImmediate(function () { return nextProps.actions.nextPhase(phase); }); });
        }
        if (nextProps.initStyles !== this.props.initStyles) {
            var nextPhaseStyle = state.initStyles.find(function (style) { return style.key === "nextPhase"; });
            if (nextPhaseStyle) {
                state.initStyles = nextProps.initStyles.concat([nextPhaseStyle]);
            }
        }
        this.setState(state);
    };
    ArenaSceneLoadMotion.prototype.render = function () {
        var _this = this;
        var _a = this.props, phase = _a.phase, numberToStyles = _a.numberToStyles, isSceneReady = _a.isSceneReady;
        var _b = this.state, initStyles = _b.initStyles, styleCalculator = _b.styleCalculator;
        return (React.createElement(TransitionMotion, { defaultStyles: initStyles, styles: styleCalculator }, function (interpolatedStyles) {
            var containerStyle, scenePlayStyle, loadingPlayStyle;
            var animationPhase = interpolatedStyles.find(function (styleObj) { return styleObj.key === "nextPhase"; }).style.phase;
            interpolatedStyles.forEach(function (styleObj) {
                var key = styleObj.key, style = styleObj.style;
                switch (key) {
                    case "container":
                        containerStyle = numberToStyles.container(style, animationPhase, isSceneReady);
                        break;
                    case "loadingPlay":
                        loadingPlayStyle = numberToStyles.loadingPlay(style, animationPhase, isSceneReady);
                        break;
                    case "scenePlay":
                        scenePlayStyle = numberToStyles.scenePlay(style, animationPhase, isSceneReady);
                        break;
                }
            });
            return (React.createElement("div", { style: containerStyle },
                React.createElement("div", { key: "loadingPlay", style: loadingPlayStyle }, _this.props.loadingPlay),
                React.createElement("div", { key: "scenePlay", style: scenePlayStyle }, _this.state.playElement)));
        }));
    };
    return ArenaSceneLoadMotion;
}(React.Component));
export default ArenaSceneLoadMotion;
