Object.defineProperty(exports, "__esModule", { value: true });
function isCurPhaseEnd(prevStyles, isSceneReady, nextPhaseCheckers) {
    return prevStyles.find(function (styleObj) {
        var key = styleObj.key, style = styleObj.style;
        switch (key) {
            case "container":
                return nextPhaseCheckers.container
                    ? nextPhaseCheckers.container(style, isSceneReady) === true
                        ? true
                        : false
                    : false;
            case "loadingPlay":
                return nextPhaseCheckers.loadingPlay
                    ? nextPhaseCheckers.loadingPlay(style, isSceneReady) === true
                        ? true
                        : false
                    : false;
            case "scenePlay":
                return nextPhaseCheckers.scenePlay
                    ? nextPhaseCheckers.scenePlay(style, isSceneReady) === true
                        ? true
                        : false
                    : false;
            default:
                return false;
        }
    }) == null
        ? false
        : true;
}
exports.isCurPhaseEnd = isCurPhaseEnd;
function calcStyle(style, phase, calculator) {
    return Object.assign({}, calculator ? calculator(style, phase) : style, {
        phase: phase
    });
}
function combineStyleCalculator(styleCalculators, phase, nextPhaseCheckers, isSceneReady, nextPhase) {
    return function (prevStyles) {
        return prevStyles.map(function (styleObj) {
            var key = styleObj.key, style = styleObj.style;
            switch (key) {
                case "container":
                    return {
                        key: "container",
                        style: calcStyle(style, phase, styleCalculators.container)
                    };
                case "loadingPlay":
                    return {
                        key: "loadingPlay",
                        style: calcStyle(style, phase, styleCalculators.loadingPlay)
                    };
                case "scenePlay":
                    return {
                        key: "scenePlay",
                        style: calcStyle(style, phase, styleCalculators.scenePlay)
                    };
                case "nextPhase":
                    if (isCurPhaseEnd(prevStyles, isSceneReady, nextPhaseCheckers)) {
                        nextPhase(style.phase);
                    }
                    return {
                        key: "nextPhase",
                        style: {
                            phase: phase
                        }
                    };
                default:
                    return styleObj;
            }
        });
    };
}
exports.combineStyleCalculator = combineStyleCalculator;
